#include "extb.h"
#include "i18n.h"
#include "extb_setup_menu.h"
#include "extb_irsend.h"

const char* mute_does[] = {
  "analog",
  "analog & digital"
};

const char* ledon[] = {
  "Aufnahme DVB",
  "Aufnahme DVB #1",
  "Aufnahme DVB #2",
  "Aufnahme DVB #3",
  "Aufnahme DVB #4",
  "Wiedergabe",
  "Wiedergabe DVD",
  "Wiedergabe Mplayer",
  "Wiedergabe MP3",
  "dummy"
};


cExtBMenuSetup::cExtBMenuSetup(void)
     //  : cOsdMenu(tr("Extension Board"), 20, 20)
{
  x = a = 0;

  gLircWatch->StartWatch();
  lirc_send("STATUS");
  Interface->Status(tr("reading settings from pic"), clrBlack, clrGreen);

  video_modes_dvb[0] = NULL;
  video_modes_dvb[1] = NULL;
  video_modes_vga[0] = NULL;
  video_modes_vga[1] = NULL;
  video_modes_aux[0] = NULL;
  video_modes_aux[1] = NULL;
  scart_pin8[0] = NULL;
  scart_pin8[1] = NULL;
  scart_pin8[2] = NULL;
  boot_device[0] = NULL;
  boot_device[1] = NULL;
  boot_device[2] = NULL;
  wait = 0;
  init_menue = true;
  video_auswahl_dvb = 0;
  video_auswahl_vga = 0;
  video_auswahl_aux = 0;

  SetHelp(tr("save"), NULL, NULL, tr("back"));
}

cExtBMenuSetup::~cExtBMenuSetup()
{
  delete[] video_modes_dvb[0];
  delete[] video_modes_dvb[1];
  delete[] video_modes_vga[0];
  delete[] video_modes_vga[1];
  delete[] video_modes_aux[0];
  delete[] video_modes_aux[1];
  delete[] scart_pin8[0];
  delete[] scart_pin8[1];
  delete[] scart_pin8[2];
  delete[] boot_device[0];
  delete[] boot_device[1];
  delete[] boot_device[2];
}

void cExtBMenuSetup::Store()
{
}

eOSState cExtBMenuSetup::ProcessKey(eKeys Key)
{
  eOSState state;
  state = cOsdMenu::ProcessKey(Key);

  if(!gLircWatch->WatchSuccess())
    {
      wait++;
      if(wait < 5)
	{
	  char buff[80];
	  strcpy(buff, tr("reading settings from pic, please wait"));
	  for(int i=0; i < wait; i++)
	    strcat(buff, ".");
	  Interface->Status(buff, clrBlack, clrGreen);
	}
      else if(wait >= 5)
	{
	  Interface->Status(tr("can't read settings from PIC"), clrBlack, clrGreen);
	}
    }
  else if(init_menue)
    {
      init_menue = false;

      scart_auswahl = 0;
      boot_auswahl = 0;

      video_modes_dvb[0] = new char[80];
      video_modes_dvb[1] = new char[80];
      video_modes_vga[0] = new char[80];
      video_modes_vga[1] = new char[80];
      video_modes_aux[0] = new char[80];
      video_modes_aux[1] = new char[80];
      scart_pin8[0] = new char[80];
      scart_pin8[1] = new char[80];
      scart_pin8[2] = new char[80];
      boot_device[0] = new char[80];
      boot_device[1] = new char[80];
      boot_device[2] = new char[80];

      strcpy(video_modes_dvb[0], tr("RGB"));
      strcpy(video_modes_dvb[1], tr("S-Video/comp. sync"));
      strcpy(video_modes_vga[0], tr("RGB"));
      strcpy(video_modes_vga[1], tr("S-Video/comp. sync"));
      strcpy(video_modes_aux[0], tr("RGB"));
      strcpy(video_modes_aux[1], tr("S-Video/comp. sync"));

      switch(gLircWatch->GetVideoModes())
	{
	case 0:
	  video_auswahl_dvb = 1;
	  video_auswahl_vga = 1;
	  video_auswahl_aux = 1;
	  break;

	case 1:
	  video_auswahl_dvb = 0;
	  video_auswahl_vga = 1;
	  video_auswahl_aux = 1;
	  break;

	case 2:
	  video_auswahl_dvb = 1;
	  video_auswahl_vga = 0;
	  video_auswahl_aux = 1;
	  break;

	case 3:
	  video_auswahl_dvb = 0;
	  video_auswahl_vga = 0;
	  video_auswahl_aux = 1;
	  break;

	case 4:
	  video_auswahl_dvb = 1;
	  video_auswahl_vga = 1;
	  video_auswahl_aux = 0;
	  break;

	case 5:
	  video_auswahl_dvb = 0;
	  video_auswahl_vga = 1;
	  video_auswahl_aux = 0;
	  break;

	case 6:
	  video_auswahl_dvb = 1;
	  video_auswahl_vga = 0;
	  video_auswahl_aux = 0;
	  break;

	case 7:
	  video_auswahl_dvb = 0;
	  video_auswahl_vga = 0;
	  video_auswahl_aux = 0;
	  break;
	  
	default:
	  ;
	}

      strcat(video_modes_dvb[video_auswahl_dvb], " (X)");
      strcat(video_modes_vga[video_auswahl_vga], " (X)");
      strcat(video_modes_aux[video_auswahl_aux], " (X)");

      strcpy(scart_pin8[0], tr("Computer an"));
      strcpy(scart_pin8[1], tr("VDR gestartet"));
      strcpy(scart_pin8[2], tr("off"));
      
      strcpy(boot_device[0], tr("VGA"));
      strcpy(boot_device[1], tr("AUX"));
      strcpy(boot_device[2], tr("off"));

      switch(gLircWatch->GetScartBootModes())
	{
	case 0:
	  scart_auswahl = 2;
	  boot_auswahl = 2;
	  break;

	case 1:
	  scart_auswahl = 0;
	  boot_auswahl = 2;
	  break;

	case 2:
	  scart_auswahl = 1;
	  boot_auswahl = 0;
	  break;

	case 4:
	  scart_auswahl = 2;
	  boot_auswahl = 0;
	  break;

	case 5:
	  scart_auswahl = 0;
	  boot_auswahl = 0;
	  break;

	case 6:
	  scart_auswahl = 1;
	  boot_auswahl = 0;
	  break;

	case 8:
	  scart_auswahl = 2;
	  boot_auswahl = 1;
	  break;

	case 9:
	  scart_auswahl = 0;
	  boot_auswahl = 1;

	case 10:
	  scart_auswahl = 1;
	  boot_auswahl = 1;

	default:
	  ;
	}

      strcat(scart_pin8[scart_auswahl], " (X)");
      strcat(boot_device[boot_auswahl], " (X)");

      Add(new cMenuEditStraItem("Bei Mute wird ausschaltet",  &a, 2, mute_does));
      Add(new cMenuEditStraItem("LED #1 einschalten", &a, 10, ledon));
      Add(new cMenuEditStraItem("LED #2 einschalten", &a, 10, ledon));
      Add(new cMenuEditStraItem("LED #3 einschalten", &a, 10, ledon));
      Add(new cMenuEditStraItem("LED #4 einschalten", &a, 10, ledon));
      Add(new cMenuEditStraItem("LED #5 einschalten", &a, 10, ledon));
      Add(new cMenuEditStraItem("LED #6 einschalten", &a, 10, ledon));

      Add(new cMenuEditStraItem(hk(tr("DVB signal")),  &video_auswahl_dvb, 2, video_modes_dvb));
      Add(new cMenuEditStraItem(hk(tr("VGA signal")),  &video_auswahl_vga, 2, video_modes_vga));
      Add(new cMenuEditStraItem(hk(tr("AUX signal")),  &video_auswahl_aux, 2, video_modes_aux));
      Add(new cMenuEditStraItem(hk(tr("Scart pin #8")),  &scart_auswahl, 3, scart_pin8));
      Add(new cMenuEditStraItem(hk(tr("Boot signal")),  &boot_auswahl, 3, boot_device));
      Interface->Status(NULL);
      Display();
    }

  if(kBlue == Key)
    {
      state = osBack;
    }
  else if(kRed == Key)
    {
      if(0 == video_auswahl_dvb)
	lirc_send("F_DVB_RGB");
      else
	lirc_send("F_DVB_CS");

      if(0 == video_auswahl_vga)
	lirc_send("F_VGA_RGB");
      else
	lirc_send("F_VGA_CS");

      if(0 == video_auswahl_aux)
	lirc_send("F_AUX_RGB");
      else
	lirc_send("F_AUX_CS");

      switch(scart_auswahl)
	{
	case 0: lirc_send("F_SC8_ON_PWR"); break;
	case 1: lirc_send("F_SC8_ON_VDR"); break;
	case 2: lirc_send("F_SC8_OFF"); break;
	}

      switch(boot_auswahl)
	{
	case 0: lirc_send("F_BOOT_VGA"); break;
	case 1: lirc_send("F_BOOT_AUX"); break;
	case 2: lirc_send("F_BOOT_OFF"); break;
	}

      state = osBack;
    }
  else
    {
    }

  return (state);
}

