/*
 * status.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id: status.c 1.7 2002/12/13 15:01:53 kls Exp $
 */

#include "extb.h"
#include "extb_status.h"
#include "extb_irsend.h"

// ---
cExtBStatusMonitor::cExtBStatusMonitor()
{
  LastVolume = cDevice::CurrentVolume();;
}

void cExtBStatusMonitor::ChannelSwitch(const cDevice *Device, int ChannelNumber)
{
#if 0
  if (ChannelNumber)
    dsyslog("channel switched to %d on DVB %d", ChannelNumber, Device->CardIndex());
  else
    dsyslog("about to switch channel on DVB %d", Device->CardIndex());
#endif
}

void cExtBStatusMonitor::SetVolume(int Volume, bool Absolute)
{
  if(LastVolume > 0 && 0 == Volume)
    {
      lirc_send("R_ANDIA");
    }
  else if(0 == LastVolume && Volume > 0)
    {
      lirc_send("S_ANDIA");
    }
  LastVolume = Volume;

  dsyslog("status: cExtBStatusMonitor::SetVolume  %d %d / Current: %d", Volume, Absolute, LastVolume);
}

void cExtBStatusMonitor::Recording(const cDevice *Device, const char *Name)
{
  dsyslog("status: cExtBStatusMonitor::Recording  %d %s", Device->CardIndex(), Name);
}

void cExtBStatusMonitor::Replaying(const cControl *Control, const char *Name)
{
  dsyslog("status: cExtBStatusMonitor::Replaying  %s", Name);
}

void cExtBStatusMonitor::OsdClear(void)
{
  static bool init = true;
  if(init)
    {
      init = false;
      lirc_send("M1");
      lirc_send("M1");
    }

  //  dsyslog("status: cExtBStatusMonitor::OsdClear");
}

void cExtBStatusMonitor::OsdTitle(const char *Title)
{
  //dsyslog("status: cExtBStatusMonitor::OsdTitle '%s'", Title);
}

void cExtBStatusMonitor::OsdStatusMessage(const char *Message)
{
  //dsyslog("status: cExtBStatusMonitor::OsdStatusMessage '%s'", Message);
}

void cExtBStatusMonitor::OsdHelpKeys(const char *Red, const char *Green, const char *Yellow, const char *Blue)
{
  //dsyslog("status: cExtBStatusMonitor::OsdHelpKeys %s - %s - %s - %s", Red, Green, Yellow, Blue);
}

void cExtBStatusMonitor::OsdCurrentItem(const char *Text)
{
  //dsyslog("status: cExtBStatusMonitor::OsdCurrentItem %s", Text);
}

void cExtBStatusMonitor::OsdTextItem(const char *Text, bool Scroll)
{
  //dsyslog("status: cExtBStatusMonitor::OsdTextItem %s %d", Text, Scroll);
}

void cExtBStatusMonitor::OsdChannel(const char *Text)
{
  //dsyslog("status: cExtBStatusMonitor::OsdChannel %s", Text);
}

void cExtBStatusMonitor::OsdProgramme(time_t PresentTime, const char *PresentTitle, const char *PresentSubtitle, time_t FollowingTime, const char *FollowingTitle, const char *FollowingSubtitle)
{
#if 0
  char buffer[25];
  struct tm tm_r;
  dsyslog("status: cExtBStatusMonitor::OsdProgramme");
  strftime(buffer, sizeof(buffer), "%R", localtime_r(&PresentTime, &tm_r));
  dsyslog("%5s %s", buffer, PresentTitle);
  dsyslog("%5s %s", "", PresentSubtitle);
  strftime(buffer, sizeof(buffer), "%R", localtime_r(&FollowingTime, &tm_r));
  dsyslog("%5s %s", buffer, FollowingTitle);
  dsyslog("%5s %s", "", FollowingSubtitle);
#endif
}
